fs        = require "fs"
path      = require "path"
{logger}  = require "./utils"
log       = logger()

fs.existsSync ?= path.existsSync

manifest =

  lookup: (rootPath)->
    for manifestName in [".manifest", "manifest.json"]
      manifestPath = (path.join rootPath, manifestName)
      break  if fs.existsSync manifestPath
    return manifestPath

  fetch: (rootPath)->
    manifestPath = @lookup rootPath
    try
      manifest = JSON.parse fs.readFileSync manifestPath
    catch err
      if err.errno is 34
        log "Manifest file does not exist '#{manifestPath}'", "red"
        process.exit 34
      else
        log "Manifest file seems corrupted '#{manifestPath}'", "red"
        log err, "red"
        process.exit 3

  set: (rootPath, key, value)->
    manifestPath = @lookup rootPath
    manifest = @fetch rootPath
    manifest.key = value
    @write rootPath, manifest

  write: (rootPath, manifest)->
    manifestPath = @lookup rootPath
    fs.writeFileSync manifestPath, (JSON.stringify manifest, null, 2)

kite = {}

module.exports = {manifest, kite}
