_ = require 'underscore'
fs        = require "fs"
path      = require "path"
{logger}  = require "./utils"

log       = logger "config"


if process.env?.HOME?
  KD_DIR              = path.join process.env.HOME, ".kd"
else
  KD_DIR              = "/root/.kd"
  
MODULE_ROOT         = path.join __dirname, "..", "modules"
CURRENT_MODULE_ROOT = path.join process.cwd(), ".kd", "modules"
USER_MODULE_ROOT    = path.join KD_DIR, "modules"

class ConfigFile

  dontSaveThemInFile: ["publicKey", "privateKey"]

  constructor: ->

    if process.env?.HOME?
      @configFile = path.join process.env.HOME, ".kd", "kdconfig"
    else
      @configFile = "/root/.kd/kdconfig"

    try
      @config = @load @configFile
    catch error
      @config = {}
      @save()

  
  get: (key)-> 
    @config[key]
  
  set: (key, value...)->
    @config[key] = value.join " "
  
  remove: (key)-> delete @config[key]
  
  getAll: -> @config

  save:->
    cloned = _.omit @config, @dontSaveThemInFile
    fs.writeFileSync @configFile, (JSON.stringify cloned, null, 2)

  load:->
    data = fs.readFileSync(@configFile).toString()
    @config = JSON.parse data


module.exports = {ConfigFile, KD_DIR, MODULE_ROOT, CURRENT_MODULE_ROOT, USER_MODULE_ROOT}
