fs            = require "fs"
os            = require "os"
nodePath      = require "path"
https         = require "https"
shell         = require "shelljs"
colors        = require "colors"
coffee        = require "coffee-script"
{exec, spawn} = require "child_process"
{ask, logger, compileDebug} = require "../lib/utils"
log           = logger "kdapp"
helpers = require '../modules/common/helpers'

module.exports = class App
  constructor: ({@config})->

  # pistachios: /\{(\w*)?(\#\w*)?((?:\.\w*)*)(\[(?:\b\w*\b)(?:\=[\"|\']?.*[\"|\']?)\])*\{([^{}]*)\}\s*\}/g

  # compile: (path)->
  #   # TODO: do we need it ???
  #   {argv: {verbose, clean}} = @options
  #     .usage("Compiles applications")
  #     .alias("v", "verbose")
  #     .alias("c", "clean")
  #     .describe("v", "Show error details")
  #     .describe("c", "Clean log messages")

  #   if clean
  #     log = (str)-> console.log str

  #   appPath = path or process.cwd()

  #   for manifestName in [".manifest", "manifest.json"]
  #     manifestPath = (nodePath.join appPath, manifestName)
  #     break  if fs.existsSync manifestPath

  #   try
  #     manifest = JSON.parse fs.readFileSync manifestPath
  #   catch err
  #     if err.errno is 34
  #       log "Manifest file does not exist '#{manifestPath}'", "red"
  #       process.exit 34
  #     else
  #       log "Manifest file seems corrupted '#{manifestPath}'", "red"
  #       log err, "red"
  #       process.exit 3

  #   files = manifest.source.blocks.app.files
  #   source = ""

  #   for file in files
  #     file = nodePath.normalize (nodePath.join path, file)  if path
  #     log "compiling #{file}...", "magenta"  if verbose

  #     if /\.coffee/.test file
  #       data = fs.readFileSync file
  #       try
  #         compiled = coffee.compile data.toString(), bare: true
  #       catch error
  #         log error, "red"
  #         if verbose 
  #           log compileDebug(file, data, error), "red"
  #         process.exit 1

  #     else if /\.js/.test file
  #       try
  #         compiled = fs.readFileSync(file).toString()
  #       catch error
  #         log error, "red"
  #         process.exit 1

  #     block = """
  #     /* BLOCK STARTS: #{file} */
  #     #{compiled}
  #     """
  #     block = block.replace @pistachios, (pistachio)-> pistachio.replace /\@/g, 'this.'
  #     source += block

  #   log "creating index.js file...", "magenta"  if verbose
  #   mainSource = """
  #   /* Compiled by KD on #{(new Date()).toString()} */
  #   (function() {
  #   /* KDAPP STARTS */
  #   #{source}
  #   /* KDAPP ENDS */
  #   }).call();
  #   """
  #   fs.writeFileSync (nodePath.join appPath, "index.js"), mainSource
  #   log "Application has been compiled!", "green"

  create: (name, path)->
    unless name 
      return log "You have to define a name to create an app!", "red"

    {argv: {sync}} = @options
      .usage("Creates a Koding Application template")
      .alias("s", "sync")
      .describe("s", "Sync kite after creation")

    appPath = nodePath.resolve path or process.cwd()

    unless @config.username
      return log """
      I don't know who you are.

      Please run: kd config username
      """, "red"

    if name.match /[^\w]/
      return log "You mustn't use special chars in kite name."

    appDir = nodePath.join appPath, "#{name}.kdapp"

    helpers.createSkeleton({
        skel: "app.kdapp"
        toPath: appDir
        env: @config
        callback: (o, e)->
          log """
          You have created a new app.
          cd #{nodePath.relative process.cwd(), appDir}
          kd app compile
          """, "green"
    })



  sync: (path)->
    # TODO: ??
    appPath = path or process.cwd()

    unless appPath.match /\.kdapp$/
      return log """
      You are not in an application directory. Application directory names
      must end with `.kdapp` extension.

      Like that example:

      kd app create appname
      cd appname.kdapp
      """, "red"


    try
      manifest = JSON.parse fs.readFileSync nodePath.join appPath, "manifest.json"
    catch err
      if err.errno is 34
        log "Manifest file does not exist '#{manifestPath}'", "red"
        process.exit 34
      else
        log "Manifest file seems corrupted '#{manifestPath}'", "red"
        log err, "red"
        process.exit 3

    ask "Please enter your Koding password:",
      hidden: true
      callback: (password)=>
        log "Connecting your Koding filesystem, please wait..."

        ftps = require "ftps"
        connection = new ftps
          host      : "ftps.koding.com"
          username  : @config['username']
          password  : password
          protocol  : "ftps"
        connection
        .raw("set ssl:verify-certificate no")
        .cd("Applications")
        .raw("mirror -Ren #{appPath}")
        .exec (err, {_err, data})->
          if err or _err
            log err
            process.exit 1
          else
            log data
            process.exit 0
