path       = require "path"
os         = require 'os'
{spawn}    = require 'child_process'
fs         = require 'fs-extra'
{template} = require 'underscore'
readDirFiles = require 'read-dir-files'
_ = require 'underscore'

module.exports =

    guard: (condition, message)->
      if condition
        console.log "Error:", message
        #console.trace new Error(message)
        throw new Error(message)

    findFile: (dir, alternatives)->
      # searches dir for files
      arr = if Array.isArray(alternatives) then alternatives else _.keys(alternatives)
      for i in arr
        f = path.join dir, i
        if fs.existsSync f
          return key: i, fullpath: f

    spawn : ({exec,params,data,error,exit})->
        timeStart = Date.Now()
        child = spawn executable,params
        child.stdout.on "data",(d)-> data? d
        child.stderr.on "data",(d)-> error? d
        child.on "exit",(c)-> 
            exit? c,"child pid:#{child.pid} was alive #{(Date.Now()-timeStart)/1000}msecs"
        return child


    manifest :
      getPath : (appPath) ->
        manifestPath = null
        for manifestName in [".manifest", "manifest.json"]
          if fs.existsSync manifestPath
            manifestPath = (nodePath.join appPath, manifestName)
            return manifestPath
        return false

      get : (appPath = process.cwd())->
        manifestPath = @getPath appPath
        try
          manifest = JSON.parse fs.readFileSync manifestPath
        catch err
          if err.errno is 34
            log "Manifest file does not exist '#{manifestPath}'", "red"
            process.exit 34
          else
            log "Manifest file seems corrupted '#{manifestPath}'", "red"
            log err, "red"
            process.exit 3 
        return manifest

        getValue: (key,path=process.cwd())->
            manifest = @manifest.get path
            return eval "manifest.#{key}"

        setValue : (key, value,path=process.cwd())->
            manifest = @manifest.get path
            eval "manifest.#{key} = value"
            return manifest
      

    write : (path,data)->
        return fs.writeFileSync path, (JSON.stringify(data,null,2))


    kite :
        compile: (path)->

    
    app:
        pistachios: /\{(\w*)?(\#\w*)?((?:\.\w*)*)(\[(?:\b\w*\b)(?:\=[\"|\']?.*[\"|\']?)\])*\{([^{}]*)\}\s*\}/g

        compile : (path) ->

          manifest = @manifest.get()

          files = manifest.source.blocks.app.files
          source = ""

          for file in files
            file = nodePath.normalize (nodePath.join path, file)  if path
            log "compiling #{file}...", "magenta"  if verbose

            if /\.coffee/.test file
              data = fs.readFileSync file
              try
                compiled = coffee.compile data.toString(), bare: true
              catch error
                log error, "red"
                if verbose 
                  log compileDebug(file, data, error), "red"
                process.exit 1

            else if /\.js/.test file
              try
                compiled = fs.readFileSync(file).toString()
              catch error
                log error, "red"
                process.exit 1

            block = """
            /* BLOCK STARTS: #{file} */
            #{compiled}
            """
            block = block.replace @pistachios, (pistachio)-> pistachio.replace /\@/g, 'this.'
            source += block

          return source

      createSkeleton: ({skel, toPath, env, callback}) ->

        applyTemplate = (templateFile, env, callback)->
            fs.readFile templateFile, (e, o)->
              try
                r = template(o.toString(), env)
                fs.writeFile templateFile, r, (e)->
                  callback e
              catch E
                console.log E
                process.exit 1

        applyTemplates = (directory, callback)->
            # get filenames and apply templates
            readDirFiles.list directory, (err, filenames)->
                if err 
                    return callback err
                cbs = 0
                for filePath in filenames
                  if path.extname(filePath) in ['.coffee', '.manifest', '.json', '.md']
                    cbs++
                    applyTemplate filePath, env, (err, templateApplied)->
                      if err
                        return callback err
                      cbs--
                fn = ()->
                  if cbs == 0
                    callback()
                    clearInterval checkInterval
                checkInterval = setInterval fn, 10
                  
        skelPath = path.normalize path.join __dirname, '..', 'resources', 'skel', skel
        fs.copy skelPath, toPath, (err)->
            if err
                console.log err
                throw new Error("Couldn't copy skeleton")
            applyTemplates(toPath, callback)

























