fs            = require "fs"
colors        = require "colors"
{ask, logger} = require "../lib/utils"

log           = logger "config"

{findFile, guard} = require '../modules/common/helpers'


module.exports = class Config

  alias:
    ls: "list"

  help:"""
  Koding configuration settings.
  """

  constructor: (@configFile)->
    guard not @configFile.config.publicKey, "you need to set your public key"


  set: (key, value...)=>
    unless key and value
      return log "You must define a key and a value to set a config variable."
    @configFile.set key, value...
    @configFile.save()

    guard not @configFile.config.publicKey, "you need to set your public key"


  get: (path)=>
    config = @configFile.getAll()
    try
      value = eval "config.#{path}"
    catch error
      log "Probably the path #{path} is wrong.", "red"
      process.exit 1

    unless value
      log "Config #{key} is not defined.", "red"
      process.exit 1

    console.log value

  remove: (path)=>
    config = @configFile.getAll()
    # not a fancy way.
    try
      eval "delete config.#{path}"
    catch error
      log "Probably the path #{path} is wrong.", "red"
      process.exit 1
    
    # @config.remove key
    @configFile.save()

  list:=>
    ask "Your config file may contain confidental information, do you want to list? [yN]",
      format: /[yN]/
      callback: (answer)=>
        if answer is "y"
          config = @config.getAll()
          @configFile.disabled.forEach (item)=> delete config[item]
          log JSON.stringify config, null, 2
        process.exit()

  alias: (alias, module)=>
    return unless alias or module
    config = @configFile.getAll()
    config.alias = {} unless config.alias
    config.alias[alias] = module
    @configFile.save()

  # helper
  username: (cb)=>
    ask "#{colors.yellow "config:"} What is your Koding username? (Leave blank to set as #{colors.blue process.env.USER}):",
      format: /^([a-z\d]+([-][a-z\d]+)*){4,25}$|^$/i # from registration code
      callback: (answer)=>
        unless answer
          log "Setting your username to #{colors.green process.env.USER}", "blue"
          answer = process.env.USER
        @set "user.name", answer
        @set "username", answer
        if typeof cb is "function"
          cb(@configFile)