Controller = require '../lib/controller'

{ConfigFile, KD_DIR, MODULE_ROOT, CURRENT_MODULE_ROOT, USER_MODULE_ROOT} = require '../lib/configFile'

fs = require 'fs'
path = require 'path'

module.exports = class Kite extends Controller

  @set
     commands:
       'help': ['help', 'Shows help']
       'default': 'help'

  getModuleList: ->
    modulePaths = [MODULE_ROOT, USER_MODULE_ROOT, CURRENT_MODULE_ROOT]

    moduleFiles = []
    for modulePath in modulePaths when fs.existsSync modulePath
      for file in fs.readdirSync(modulePath)
        fpath = path.join(modulePath, file)
        if fpath not in moduleFiles
          moduleFiles.push(fpath) 
    moduleFiles

  help: ->
    moduleList = @getModuleList()
    console.log """
      Usage:

        kd <module> <command> [arguments]

      The modules are:

      """
    console.log "  " + (path.basename module.replace /.coffee$|.kdmodule$/, '' for module in moduleList when module.match /.coffee$|.kdmodule$/).join ", "
    console.log """

      Use "kd <module> help" for more information about that module.
    """

