helpers = require '../modules/common/helpers'
vows    = require 'vows'
assert  = require 'assert'
fs      = require 'fs-extra'
KDKite = require '../lib/kdkite'

vows
  .describe('Copy skeleton')
  .addBatch
    'when creating a kite from skeleton':
        topic: ->
          try
            cb = this.callback
            fs.remove '/tmp/kd/', (err)->
              console.log "here2"
              fs.mkdirsSync "/tmp/kd"
              # ignore error
              env = 
                name: 'kitefoobar123'
                username: 'ybrs'
                mail: "themailofuser@foobarbaz.com"

              helpers.createSkeleton
                skel: 'worker.kite'
                toPath: '/tmp/kd/kd-tests/'
                env: env
                callback: (o, e)->
                  fs.readFile '/tmp/kd/kd-tests/index.coffee', 'utf8', (err, f)->
                    cb(e, f, env)
          catch error
            console.log error
          return
        'we get the files': (e, f, env) ->
            assert f.indexOf(env.username) > 0, "env username not in file"

  .addBatch
    'init a kite with dependencies':
      topic: ->
            try
              cb = this.callback

              # we create a kite dependency tree here
              # mykite
              #  \_ kitefoo1
              #  \_ kitefoo2
              #        \_ kitefoo3
              #              \_ kitefoo4

              create_kite = (name, callback)->
                kite = new KDKite("/tmp/kd/#{name}")
                kite.name = name
                kite.username = 'ybrs'
                kite.mail = 'themailofuser@foobarbaz.com'
                kite.version = '1.0.1'
                kite.cloneFrom 'worker.kite', ->
                  kite.on 'ready', =>
                    console.log 'kite ready'
                    callback(false, kite)
                  kite.prepare()
                return kite

              kitefoo1 = false
              create_kite 'kitefoo1', (err, kite)->
                kitefoo1 = kite

              kitefoo2 = false
              create_kite 'kitefoo2', (err, kite)->
                kitefoo2 = kite

              kitefoo3 = false
              create_kite 'kitefoo3', (err, kite)->
                kitefoo3 = kite

              kitefoo4 = false
              create_kite 'kitefoo4', (err, kite)->
                kitefoo4 = kite

              create_dependency_chain = ()=>
                mykite = new KDKite('/tmp/kd/kd-tests')
                mykite.on 'ready', =>
                    mykite.addDependency '/tmp/kd/kitefoo1', (err)=>
                      mykite.addDependency '/tmp/kd/kitefoo2', (err)=>
                        kitefoo2.addDependency '/tmp/kd/kitefoo3', (err)=>
                          kitefoo3.addDependency '/tmp/kd/kitefoo4', (err)=>
                            console.log "added dependencies !!!!!!!!!!!!!!!!!"
                            console.log "???????", kitefoo2.manifest.dependencies
                            assert '/tmp/kd/kitefoo3' in kitefoo2.manifest.dependencies
                            console.log "aaaaaaaaaaaaaaaa    999999999999999999"
                            cb false, mykite, kitefoo1, kitefoo2, kitefoo3, kitefoo4
                mykite.prepare()

              ti = setInterval ->
                if false not in [kitefoo1, kitefoo2, kitefoo3, kitefoo4]
                  clearTimeout ti
                  create_dependency_chain()
              , 1000


            catch Error
              console.trace Error
            return 

      'we get the name': (err, mykite, kitefoo1, kitefoo2, kitefoo3, kitefoo4)->
            assert fs.existsSync '/tmp/kd/kitefoo1/manifest.json'
            assert kitefoo1.name == 'kitefoo1'
            assert mykite.name == 'kitefoobar123'
            deps = JSON.parse(fs.readFileSync('/tmp/kd/kd-tests/manifest.json').toString()).dependencies
            console.log kitefoo1.name, deps
            assert "/tmp/kd/#{kitefoo1.name}" in deps
            assert "/tmp/kd/#{kitefoo2.name}" in deps
            console.log 'dependencies', kitefoo2.manifest.dependencies
            assert '/tmp/kd/kitefoo3' in kitefoo2.manifest.dependencies
  
  .addBatch
    'prepare a kite with dependencies':
      topic: ->
        try
          cb = this.callback
          console.log "=========================="
          mykite = new KDKite('/tmp/kd/kd-tests')
          mykite.on 'ready', =>
            cb false, mykite
          mykite.prepare()
          return
        catch E
          console.trace E
      'dependencies installed': (err, mykite)->
        assert fs.existsSync "/tmp/kd/kd-tests/kites/kitefoo1"
        assert fs.existsSync "/tmp/kd/kd-tests/kites/kitefoo2/manifest.json"
        assert fs.existsSync "/tmp/kd/kd-tests/kites/kitefoo2"
        assert fs.existsSync "/tmp/kd/kd-tests/kites/kitefoo2/manifest.json"

        assert fs.existsSync "/tmp/kd/kd-tests/kites/kitefoo2/kites/kitefoo3"
        assert fs.existsSync "/tmp/kd/kd-tests/kites/kitefoo2/kites/kitefoo3/manifest.json"

        assert fs.existsSync "/tmp/kd/kd-tests/kites/kitefoo2/kites/kitefoo3/kites/kitefoo4"
        assert fs.existsSync "/tmp/kd/kd-tests/kites/kitefoo2/kites/kitefoo3/kites/kitefoo4/manifest.json"
  .export(module)